import java.util.ArrayList;
import java.util.Arrays;

public class MyArrayList <T>{

    private Object[] element = new Object[10];

    public MyArrayList() {

    }

    public MyArrayList(int i){
        this.element = new Object[i];
    }

    public void add(T thing) {
        checkCurrentCap();
        int index = 0;
        for (Object o : element) {
            if (o == null) {
                element[index] = thing;
                break;
            }
            index++;
        }
    }

    public void add(T thing, int index){
        checkCurrentCap();
        if(element[index] == null){
            this.set(index, thing);
        } else {
            element = shiftArray(thing, index);
        }
    }

    public Object[] shiftArray( T thing, int index){
        Object[] newArr = new Object[element.length + 1];
        for(int i = 0 ; i < index; i++){
            newArr[i] = element[i];
        }
        newArr[index] = thing;
        for(int j = index+1; j < element.length; j++){
            newArr[j] = element[j-1];
        }
        return newArr;
    }

    public void checkCurrentCap(){
        if (!(element[element.length-1] == null)){
            Object[] temp = element;
            element = new Object[element.length*2];
            arrCopy(element, temp);
        }
    }

    public void arrCopy(Object[] arrTo, Object[] arrFrom){
        int index = 0;
        for(Object o: arrFrom){
            arrTo[index] = o;
            index++;
        }
    }

    public int sizeWithNull(){
        return element.length;
    }

    public int size(){
        long size = Arrays.stream(element)
                          .filter(s -> (s != null))
                          .count();
        return (int) size;
    }

    public void trimArray(){
        Object[] trimmed = Arrays.stream(element)
                                 .filter((s->(s!=null)))
                                 .toArray();
        element = trimmed;
    }

    public T get(int index) {
        return (T)element[index];
    }

    public void remove(T i) {
        int index = 0;
        for(Object e: element){
            if(e.equals(i)){
                element[index] = null;
                break;
            }
            index++;
        }
        trimArray();
    }

    public void set(int i, T thing) {
        if(i > element.length-1){
            arrayExpander(i);
        }
        this.element[i] = thing;
    }

    public void arrayExpander(int i){
        Object[] temp = element;
        element = new Object[element.length+i];
        arrCopy(element, temp);
    }

    public void clear() {
        for(int i = 0; i < element.length; i++){
            element[i] = null;
        }
    }

    public boolean isEmpty() {
        for(Object o: element){
            if (!(o ==null)){
                return false;
            }
        }
        return true;
    }

    public boolean contains(T i) {
        for(Object o: element){
            if(o == null){
                continue;
            }
            if (o.equals(i)){
                return true;
            }
        }
        return false;
    }
}
