import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class MyArrayListTest {

    @Test
    public void addTest(){
        //Integer[] input = {1, 2, 4, 5, 6, 7};
        MyArrayList<Integer> myArrayList = new MyArrayList<Integer>();
        myArrayList.add(1);
        myArrayList.add(2);
        int expected = 2;
        int actual = myArrayList.size();
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void addTest1(){
        //Integer[] input = {1, 2, 4, 5, 6, 7};
        MyArrayList<String> myArrayList = new MyArrayList<>();
        myArrayList.add("rachelle");
        myArrayList.add("chad");
        int expected = 2;
        int actual = myArrayList.size();
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void addTest2(){
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(1);
        myArrayList.add(2);
        myArrayList.add(3, 1);
        Assert.assertTrue(myArrayList.get(1)==3);
        Assert.assertTrue(myArrayList.get(2) == 2);
        Assert.assertTrue(myArrayList.size() == 3);
    }



    @Test
    public void getTest(){
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(2);
        Integer expected = 2;
        Integer actual = myArrayList.get(0);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void get1Test(){
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(2);
        Integer actual = myArrayList.get(1);
        Assert.assertNull(actual);
    }

    @Test (expected = ArrayIndexOutOfBoundsException.class)
    public void get2Test(){
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(2);
        Integer actual = myArrayList.get(11);
    }

    @Test
    public void removeTest(){
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(2);
        myArrayList.add(1);
        myArrayList.remove(2);
        int expected = 1;
        int actual = myArrayList.size();
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void setTest(){
        MyArrayList<String> myArrayList = new MyArrayList<>();
        myArrayList.set(1, "dog");
        String expected = "dog";
        String actual = myArrayList.get(1);
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void setTest1(){
        MyArrayList<String> myArrayList = new MyArrayList<>();
        myArrayList.set(12, "dog");
        myArrayList.set(2, "cat");
        String expected = "cat";
        int expectedSize = 22;
        String actual = myArrayList.get(2);
        Assert.assertEquals(expected, actual);
        Assert.assertTrue(expectedSize == myArrayList.sizeWithNull());
    }

    @Test
    public void arrayExpanderTest(){
        MyArrayList<String> myArrayList = new MyArrayList<>();
        myArrayList.arrayExpander(2);
        int expected = 12;
        int actual = myArrayList.sizeWithNull();
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void clearTest(){
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(2);
        myArrayList.add(3);
        myArrayList.clear();
        Integer expected = null;
        Integer sizeExpected = 10;
        Assert.assertEquals(expected, myArrayList.get(1));
        Assert.assertTrue(sizeExpected == myArrayList.sizeWithNull());

    }

    @Test
    public void isEmptyTest(){
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        boolean actual = myArrayList.isEmpty();
        Assert.assertTrue(actual);
    }

    @Test
    public void isEmptyTest1(){
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(1);
        boolean actual = myArrayList.isEmpty();
        Assert.assertFalse(actual);
    }

    @Test
    public void containsTest(){
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(1);
        boolean contains = myArrayList.contains(3);
        Assert.assertFalse(contains);
    }

    @Test
    public void containsTest1(){
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(1);
        myArrayList.add(1);
        myArrayList.add(4);
        myArrayList.add(1);
        myArrayList.add(1);
        myArrayList.add(1);
        boolean contains = myArrayList.contains(4);
        Assert.assertTrue(contains);
    }

    @Test
    public void sizeTest(){
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(1);
        myArrayList.add(1);
        myArrayList.add(4);
        myArrayList.add(1);
        myArrayList.add(1);
        myArrayList.add(1);
        myArrayList.add(1);
        myArrayList.add(1);
        myArrayList.add(1);
        myArrayList.add(1);
        myArrayList.add(1);
        Assert.assertTrue(myArrayList.size() == 11);
    }

    @Test
    public void trimArrayTest(){
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(1);
        myArrayList.add(4);
        myArrayList.add(1);
        myArrayList.trimArray();
        Assert.assertTrue(myArrayList.sizeWithNull() == 3);

    }
}
